/***********************************************************************
*
* Copyright (c) 2021-2022 Barbara Geller and Ansel Sermersheim
*
* This example is free software, released under the BSD 2-Clause license.
* For license details refer to LICENSE provided with this project.
*
* CopperSpice is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* https://opensource.org/licenses/BSD-2-Clause
*
***********************************************************************/

// ellipse
void DrawArea::paintEvent(QPaintEvent *)
{
   QRect rect(30, 60, 240, 180);

   QPainter painter(this);
   painter.setPen(pen);
   painter.setBrush(brush);
   painter.setRenderHint(QPainter::Antialiasing, true);

   painter.save();
   painter.translate(175, 10);
   painter.drawEllipse(rect);
   painter.restore();

   painter.setRenderHint(QPainter::Antialiasing, false);
   painter.setPen(palette().dark().color());
   painter.setBrush(Qt::NoBrush);

   painter.drawRect(QRect(0, 0, width() - 1, height() - 1));
}

// rounded rectangle
void DrawArea::paintEvent(QPaintEvent *)
{
   QRect rect(30, 60, 240, 180);

   QPainter painter(this);
   painter.setPen(pen);
   painter.setBrush(brush);
   painter.setRenderHint(QPainter::Antialiasing, true);

   painter.save();
   painter.translate(175, 10);
   painter.drawRoundedRect(rect, 25, 25, Qt::RelativeSize);
   painter.restore();

   painter.setRenderHint(QPainter::Antialiasing, false);
   painter.setPen(palette().dark().color());
   painter.setBrush(Qt::NoBrush);

   painter.drawRect(QRect(0, 0, width() - 1, height() - 1));
}

// path
void DrawArea::paintEvent(QPaintEvent *)
{
   QPainterPath path;
   path.moveTo(60, 240);
   path.lineTo(60, 90);
   path.cubicTo(240, 0, 150, 150, 240, 240);

   QPainter painter(this);
   painter.setPen(pen);
   painter.setBrush(brush);
   painter.setRenderHint(QPainter::Antialiasing, true);

   painter.save();
   painter.translate(175, 10);
   painter.drawPath(path);
   painter.restore();

   painter.setRenderHint(QPainter::Antialiasing, false);
   painter.setPen(palette().dark().color());
   painter.setBrush(Qt::NoBrush);

   painter.drawRect(QRect(0, 0, width() - 1, height() - 1));
}